#include <stdlib.h>
#include "anamod.h"

/*
 * test for legal and illegal names
 */
int main(int argc,char **argv)
{
  PetscErrorCode ierr;
  PetscInitialize(&argc,&argv,0,0);
  ierr = AnaModInitialize(); CHKERRQ(ierr);

  /* one valid call */
  ierr = RegisterModule
    ("catname","cmpname",ANALYSISINTEGER,NULL); CHKERRQ(ierr);

  /* the next register call is invalid because of the colon in the name;
   * just for the sake of testing we catch the error
   */
  ierr = PetscPushErrorHandler(PetscReturnErrorHandler,NULL); CHKERRQ(ierr);
  ierr = RegisterModule
    ("cat:name","cmpname",ANALYSISINTEGER,NULL); 
  if (ierr) {
    printf("Illegal AnaMod name detected\n"); PetscFunctionReturn(1);
  }

  ierr = AnaModFinalize(); CHKERRQ(ierr);
  PetscFinalize();
  return 0;
}
