#include <stdlib.h>
#include "anamod.h"

/*
 * test for module placeholder creation
 */
int main(int argc,char **argv)
{
  PetscBool flg; PetscErrorCode ierr;
  PetscInitialize(&argc,&argv,0,0);
  ierr = AnaModInitialize(); CHKERRQ(ierr);

  ierr = RegisterModule
    ("catname","cmpname",ANALYSISINTEGER,NULL); CHKERRQ(ierr);
  ierr = HasComputeModule
    ("catname","cmpname",&flg); CHKERRQ(ierr);
  if (!flg) SETERRQ(PETSC_COMM_SELF,1,"Should have reported success");
  ierr = ComputeQuantity
    ((AnaModNumericalProblem)ierr,"catname","cmpname",
     (AnalysisItem*)&ierr,PETSC_NULL,&flg); CHKERRQ(ierr);
  if (flg) SETERRQ(PETSC_COMM_SELF,1,"Should have reported failure");

  ierr = AnaModFinalize(); CHKERRQ(ierr);
  PetscFinalize();
  PetscFunctionReturn(0);
}
