#include <stdlib.h>
#include "anamod.h"

/*
 * test for simple modules
 */
static int IntModule
(AnaModNumericalProblem problem,AnalysisItem *v,int *lv,PetscBool *flg)
{
  PetscFunctionBegin;
  printf("I am computing 5\n");
  v->i = 5;
  PetscFunctionReturn(0);
}

static int Int2Module
(AnaModNumericalProblem problem,AnalysisItem *v,int *lv,PetscBool *flg)
{
  PetscFunctionBegin;
  printf("I am adding 1 to %d\n",*(int*)problem);
  v->i = *(int*)problem + 1;
  PetscFunctionReturn(0);
}

int main(int argc,char **argv)
{
  AnalysisItem result; int itmp;
  PetscBool flg; PetscErrorCode ierr;
  PetscInitialize(&argc,&argv,0,0);
  ierr = AnaModInitialize(); CHKERRQ(ierr);

  ierr = RegisterModule
    ("cat1","int",ANALYSISINTEGER,&IntModule); CHKERRQ(ierr);
  ierr = ComputeQuantity
    (NULL,"cat1","int",&result,NULL,&flg); CHKERRQ(ierr);
  if (!flg)
    printf("failed to compute int\n");
  else
    printf("computed int %d\n",result.i);

  ierr = RegisterModule
    ("cat1","int2",ANALYSISINTEGER,&Int2Module); CHKERRQ(ierr);
  itmp = 36;
  ierr = ComputeQuantity
    ((AnaModNumericalProblem)&itmp,"cat1","int2",
     &result,NULL,&flg); CHKERRQ(ierr);
  if (!flg)
    printf("failed to compute int2\n");
  else
    printf("computed int2 %d\n",result.i);

  ierr = AnaModFinalize(); CHKERRQ(ierr);

  PetscFinalize();
  return 0;
}
