#include <stdlib.h>
#include "anamod.h"
#include "anamodsalsamodules.h"
#include "petsc.h"

int main(int argc,char **argv)
{
  PetscErrorCode ierr;
  PetscFunctionBegin;
  PetscInitialize(&argc,&argv,0,0);
  ierr = AnaModInitialize(); CHKERRQ(ierr);
  
  ierr = AnaModRegisterSalsaModules(); CHKERRQ(ierr);
  {
    int ncat,icat; const char **cats;
    ierr = GetCategories(&ncat,&cats); CHKERRQ(ierr);
    for (icat=0; icat<ncat; icat++) {
      int ncmp,icmp; const char **cmps; AnalysisDataType *types;
      ierr = CategoryGetModules
	(cats[icat],&cmps,&types,NULL,&ncmp); CHKERRQ(ierr);
      for (icmp=0; icmp<ncmp; icmp++) {
	printf("Category <%s> Component <%s> Type <%d>\n",
	       cats[icat],cmps[icmp],types[icmp]);
      }
    }
  }

  ierr = AnaModFinalize(); CHKERRQ(ierr);
  PetscFinalize();
  PetscFunctionReturn(0);
}
