#include <stdlib.h>
#include "anamod.h"

/*
 * More simple modules
 */
int IntModule
(AnaModNumericalProblem problem,AnalysisItem *v,int *lv,PetscBool *flg)
{
  PetscFunctionBegin;
  printf("I am computing 5\n");
  v->i = 5;
  PetscFunctionReturn(0);
}

int RealModule
(AnaModNumericalProblem problem,AnalysisItem *v,int *lv,PetscBool *flg)
{
  PetscFunctionBegin;
  printf("I am multiplying %e by 2.2\n",*(double*)problem);
  v->r = *(double*)problem * 2.2;
  PetscFunctionReturn(0);
}

int main(int argc,char **argv)
{
  AnalysisItem result; double rtmp;
  PetscBool flg; PetscErrorCode ierr;
  PetscInitialize(&argc,&argv,0,0);
  ierr = AnaModInitialize(); CHKERRQ(ierr);

  ierr = RegisterModule
    ("cat1","int",ANALYSISINTEGER,&IntModule); CHKERRQ(ierr);
  ierr = ComputeQuantity
    (NULL,"cat1","int",&result,NULL,&flg); CHKERRQ(ierr);
  if (!flg)
    printf("failed to compute int\n");
  else
    printf("computed int %d\n",result.i);

  ierr = RegisterModule
    ("cat1","int2",ANALYSISDOUBLE,&RealModule); CHKERRQ(ierr);
  rtmp = 36.1;
  ierr = ComputeQuantity
    ((AnaModNumericalProblem)&rtmp,"cat1","int2",
     &result,NULL,&flg); CHKERRQ(ierr);
  if (!flg)
    printf("failed to compute int2\n");
  else
    printf("computed real %e\n",result.r);

  ierr = AnaModFinalize(); CHKERRQ(ierr);

  PetscFinalize();
  return 0;
}
