#include <stdlib.h>
#include "nmd.h"
#include "nmd5.c"

/*! Test hdf5 dumping of scalar values */
int main(int argc,char **argv) {
  NMD_metadata nmd; NMDErrorCode ierr; 
  NMDTruth flg; int i; double r;
  PetscFunctionBegin;
  PetscInitialize(&argc,&argv,0,0);

  ierr = NMDCreateObject(&nmd); NMD_ERR_RETURN(ierr);

  i = 5;
  ierr = NMDSetValue(nmd,"cat1","cmp-i",NMDInt,&i); NMD_ERR_RETURN(ierr);
  i = 6;
  ierr = NMDSetValue(nmd,"cat1","cmp-ii",NMDInt,&i); NMD_ERR_RETURN(ierr);

  i = 27;
  ierr = NMDGetValue
    (nmd,"cat1","cmp-ii",NULL,(void*)&i,&flg); NMD_ERR_RETURN(ierr);
  if (!flg || i!=6) 
    NMD_ERR_REPORT("Trouble retrieving cmp-ii");
  ierr = NMDGetValue
    (nmd,"cat2","cmp-ii",NULL,(void*)&i,&flg); NMD_ERR_RETURN(ierr);
  if (flg)
    NMD_ERR_REPORT("This should not happen1");

  r = 4.17;
  ierr = NMDSetValue(nmd,"cat2","cmp-i",NMDReal,&r); NMD_ERR_RETURN(ierr);

  ierr = NMDObjectDumpToHDF5(nmd,"u27.h5"); NMD_ERR_RETURN(ierr);
  
  ierr = NMDDestroyObject(nmd); NMD_ERR_RETURN(ierr);

  PetscFinalize();
  PetscFunctionReturn(0);
}
