#include <stdlib.h>
#include "nmd.h"

/*! Test setting and getting of array values */
int main(int argc,char **argv) {
  NMD_metadata nmd; NMDErrorCode ierr; 
  NMDTruth flg; NMDDataType t;
  int *ii,*iir,len; double *rr;
  PetscFunctionBegin;
  PetscInitialize(&argc,&argv,0,0);

  ierr = NMDCreateObject(&nmd); NMD_ERR_RETURN(ierr);

  NMD_MALLOC(ii,5,int,"int array");
  NMD_MALLOC(rr,2,double,"double array");
  ii[2] = 15; rr[1] = 37.2;

  ierr = NMDSetArrayValue
    (nmd,"ctg","i array",NMDIntarray,&ii,5); NMD_ERR_RETURN(ierr);
  ierr = NMDSetArrayValue
    (nmd,"ctg","r array",NMDRealarray,&rr,2); NMD_ERR_RETURN(ierr);

  ierr = NMDGetArrayValue
    (nmd,"ctg","r array",NULL,NULL,&len,&flg); NMD_ERR_RETURN(ierr);
  if (!flg) NMD_ERR_REPORT("Could not get r array info");
  if (len!=2) NMD_ERR_REPORTi("r array length mismatch",len);

  ierr = NMDGetArrayValue
    (nmd,"ctg","i array",&t,(void*)&iir,NULL,&flg); NMD_ERR_RETURN(ierr);
  if (!flg) NMD_ERR_REPORT("Could not get i array");
  if (t!=NMDIntarray) NMD_ERR_REPORTi("i array type mismatch",(int)t);
  if (iir[2]!=15) NMD_ERR_REPORTi("i array value problem",iir[2]);

  NMD_FREE(ii); NMD_FREE(rr);
  ierr = NMDDestroyObject(nmd); NMD_ERR_RETURN(ierr);

  PetscFinalize();
  PetscFunctionReturn(0);
}
